<template>
  <v-dialog
    v-model="dialog"
    width="30em"
  >
    <v-card v-if="!!person">
      <v-card-title>{{person.fullname}}
        <v-spacer />
        <v-tooltip bottom="bottom">
          <template v-slot:activator="{ on }">
            <v-btn
              v-on="on"
              icon="icon"
              @click="$router.push({ name: 'person', params: { id: person.id }})"
            >
              <v-icon>mdi-plus</v-icon>
            </v-btn>
          </template>
          <span>More details</span>
        </v-tooltip>
      </v-card-title>
      <person-data :person="person" />
    </v-card>
  </v-dialog>
</template>

<script lang="ts">
import Vue from 'vue'

import personInfoQuery from '@/gql/PersonInfo.gql'
import PersonData from '@/components/utils/PersonData.vue'

export default Vue.extend({
  name: 'PersonInfoDialog',
  components: {
    PersonData
  },
  props: {
    value: { type: Boolean, required: true },
    id: { type: String, default: null }
  },
  computed: {
    dialog: {
      get (): boolean {
        return this.value
      },
      set (v: boolean) {
        this.$emit('input', v)
      }
    }
  },
  apollo: {
    person: {
      query: personInfoQuery,
      variables (): { id: string } {
        return {
          id: this.id
        }
      },
      skip (): boolean {
        return !this.id
      }
    }
  }
})
</script>
